﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PivotGridCustomDataSelector
{
    using System.Globalization;

    using Infragistics.Olap;

    class CustomAggregator : AggregationContext
    {
        protected override object Sum(object addValue, object currentSum)
        {
            var result = base.Sum(addValue, currentSum);

            Type dataType = addValue.GetType();

            if (dataType == typeof(int))
            {
                return (Convert.ToInt32(addValue, CultureInfo.InvariantCulture) * 2) + Convert.ToInt32(currentSum, CultureInfo.InvariantCulture);
            }

            if (dataType == typeof(int?))
            {
                return (Convert.ToInt32(addValue, CultureInfo.InvariantCulture) * 2) + Convert.ToInt32(currentSum, CultureInfo.InvariantCulture);
            }

            if (dataType == typeof(long))
            {
                return (Convert.ToInt64(addValue, CultureInfo.InvariantCulture) * 2) + Convert.ToInt64(currentSum, CultureInfo.InvariantCulture);
            }

            if (dataType == typeof(long?))
            {
                return (Convert.ToInt64(addValue, CultureInfo.InvariantCulture) * 2) + Convert.ToInt64(currentSum, CultureInfo.InvariantCulture);
            }

            if (dataType == typeof(double))
            {
                return (Convert.ToDouble(addValue, CultureInfo.InvariantCulture) * 2) + Convert.ToDouble(currentSum, CultureInfo.InvariantCulture);
            }

            if (dataType == typeof(double?))
            {
                return (Convert.ToDouble(addValue, CultureInfo.InvariantCulture) * 2) + Convert.ToDouble(currentSum, CultureInfo.InvariantCulture);
            }

            if (dataType == typeof(decimal))
            {
                return (Convert.ToDecimal(addValue, CultureInfo.InvariantCulture) * 2) + Convert.ToDecimal(currentSum, CultureInfo.InvariantCulture);
            }

            if (dataType == typeof(decimal?))
            {
                return (Convert.ToDecimal(addValue, CultureInfo.InvariantCulture) * 2) + Convert.ToDecimal(currentSum, CultureInfo.InvariantCulture);
            }

            if (dataType == typeof(float))
            {
                return (Convert.ToDecimal(addValue, CultureInfo.InvariantCulture) * 2) + Convert.ToDecimal(currentSum, CultureInfo.InvariantCulture);
            }

            if (dataType == typeof(float?))
            {
                return (Convert.ToDecimal(addValue, CultureInfo.InvariantCulture) * 2) + Convert.ToDecimal(currentSum, CultureInfo.InvariantCulture);
            }

            return null;
        }
    }
}
